<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2023 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2023-01-13
 */
define('IN_DOUCO', true);

require (dirname(__FILE__) . '/include/init.php');

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 扩展数据模块
if ($_OPEN['data']) {
    include_once (ROOT_PATH . 'include/data.class.php');
    $dou_data = new Data();
}

$smarty->assign('rec', $rec);
$smarty->assign('cur', 'data');

/**
 * +----------------------------------------------------------
 * 数据列表
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    $dou->dou_header('index.php');
} 

/**
 * +----------------------------------------------------------
 * 数据添加
 * +----------------------------------------------------------
 */
elseif ($rec == 'add') {
    // 验证并获取合法的ID
    $module = $check->is_letter($_REQUEST['module']) ? $_REQUEST['module'] : exit;
    $item_id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : exit;

    // 项目详情
    $item = array (
            "module" => $module,
            "id" => $item_id,
            "name" => $dou->get_value($module, ($module == 'product' ? 'name' : 'title'), "id = '$item_id'"),
            "url" => $module . '.php?rec=edit&id=' . $item_id
    );
 
    $smarty->assign('ur_here', $_LANG['data_add']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['back'] . $_LANG[$module . '_edit'],
            'href' => $item['url']
    ));
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
 
    $class_list = $dou->get_no_repeat_value('data', 'class', '', false, "module = '$module' AND item_id = '$item_id'");
    if (!$class_list)
        $data['class'] = 'default#扩展数据';
    
    // 赋值给模板
    $smarty->assign('form_action', 'insert');
    $smarty->assign('data', $data);
    $smarty->assign('class_list', $class_list);
    $smarty->assign('btn_lang', $dou->btn_lang('data', '', 'name, text, link'));
    $smarty->assign('item', $item);
    
    $smarty->display('data.htm');
} 

elseif ($rec == 'insert') {
    if (empty($_POST['name']))
        $dou->dou_msg($_LANG['data_name'] . $_LANG['is_empty']);
    
    if (empty($_POST['class']))
        $dou->dou_msg($_LANG['data_class'] . $_LANG['is_empty']);

    // 文件上传盒子
    include_once (ROOT_PATH . 'include/file.class.php');
    $file = new File('images/' . $_POST['module'] . '/data/');
    $image = $file->box('data', $dou->auto_id('data'), 'image', 'main');
        
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    $sql = "INSERT INTO " . $dou->table('data') . " (id, module, item_id, name, class, text, image, link)" . " VALUES (NULL, '$_POST[module]', '$_POST[item_id]', '$_POST[name]', '$_POST[class]', '$_POST[text]', '$image', '$_POST[link]')";
    $dou->query($sql);
 
    // 返回链接
    $item_url = $_POST['module'] . '.php?rec=edit&id=' . $_POST['item_id'];
    
    $dou->create_admin_log($_LANG['data_add'] . ': ' . $_POST['name']);
    $dou->dou_header($item_url);
} 

/**
 * +----------------------------------------------------------
 * 数据编辑
 * +----------------------------------------------------------
 */
elseif ($rec == 'edit') {
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
    
    $data = $dou->get_row('data', '*', "id = '$id'");

    // 项目详情
    $item = array (
            "module" => $data['module'],
            "id" => $data['item_id'],
            "name" => $dou->get_value($data['module'], ($data['module'] == 'product' ? 'name' : 'title'), "id = '$data[item_id]'"),
            "url" => $data['module'] . '.php?rec=edit&id=' . $data['item_id']
    );
    
    $smarty->assign('ur_here', $_LANG['data_edit']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['back'] . $_LANG[$item['module'] . '_edit'],
            'href' => $item['url']
    ));
    
    // 格式化数据
    $data['image'] = $dou->dou_file($data['image']);
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('form_action', 'update');
    $smarty->assign('data', $data);
    $smarty->assign('class_list', $dou->get_no_repeat_value('data', 'class', $data['class'], false, "module = '$data[module]' AND item_id = '$data[item_id]'"));
    $smarty->assign('btn_lang', $dou->btn_lang('data', $id, 'name, text, link'));
    $smarty->assign('item', $item);
    
    $smarty->display('data.htm');
} 

elseif ($rec == 'update') {
    // 验证并获取合法的ID
    $id = $check->is_number($_POST['id']) ? $_POST['id'] : '';
    
    if (empty($_POST['name']))
        $dou->dou_msg($_LANG['data_name'] . $_LANG['is_empty']);
    
    if (empty($_POST['class']))
        $dou->dou_msg($_LANG['data_class'] . $_LANG['is_empty']);
 
    // 返回链接
    $data = $dou->get_row('data', 'module, item_id', "id = '$id'");
    $item_url = $data['module'] . '.php?rec=edit&id=' . $data['item_id'];

    // 文件上传盒子
    include_once (ROOT_PATH . 'include/file.class.php');
    $file = new File('images/' . $data['module'] . '/data/');
    $image = $file->box('data', $id, 'image', 'main');
    $image = $image ? ", image = '" . $image . "'" : '';
    
    // CSRF防御令牌验证$id
    $firewall->check_token($_POST['token']);
    
    $sql = "UPDATE " . $dou->table('data') . " SET name = '$_POST[name]', class = '$_POST[class]', text = '$_POST[text]'" . $image . ", link = '$_POST[link]' WHERE id = '$id'";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['data_edit'] . ': ' . $_POST['name']);
    $dou->dou_header($item_url);
}

/**
 * +----------------------------------------------------------
 * 数据删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'copy') {
    // 验证并获取合法的ID
    $module = $check->is_letter($_REQUEST['module']) ? $_REQUEST['module'] : exit;
    $item_id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : exit;
 
    // 获取当前模块最后一次添加数据的项目ID
    $last_item_id = $dou->get_one("SELECT item_id FROM " . $dou->table('data') . " WHERE module = '$module' ORDER BY id DESC");

    $sql = "SELECT * FROM " . $dou->table('data') . " WHERE module = '$module' AND item_id = '$last_item_id' ORDER BY id ASC";
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $sql = "INSERT INTO " . $dou->table('data') . " (id, module, item_id, name, class, text, image, link)" . " VALUES (NULL, '$row[module]', '$item_id', '$row[name]', '$row[class]', '', '', '')";
        $dou->query($sql);
    }
 
    // 返回链接
    $dou->dou_header($module . '.php?rec=edit&id=' . $item_id);
}

/**
 * +----------------------------------------------------------
 * 数据删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'del') {
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : $dou->dou_msg($_LANG['illegal'], 'data.php');
    
    $data = $dou->get_row('data', 'id, module, item_id, name, image', "id = '$id'");
    
    // 删除相应商品图片
    $dou->del_file($data['image']);

    // 返回链接
    $item_url = $data['module'] . '.php?rec=edit&id=' . $data['item_id'];

    $dou->create_admin_log($_LANG['data_del'] . ': ' . $name);
    $dou->delete('data', "id = $id", $item_url);
}

?>